# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .credential import Credential
from .presentation_id import PresentationId
from .presentation_type import PresentationType

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Presentation(pydantic.BaseModel):
    """
    A presentation of credentials. [Terminology](https://www.w3.org/TR/vc-data-model/#dfn-presentations).
    """

    type: PresentationType
    verifiable_credential: typing.List[Credential] = pydantic.Field()
    """
    A list of verifiable credentials. [Terminology](https://www.w3.org/TR/vc-data-model/#dfn-verifiable-credential).
    """

    id: typing.Optional[PresentationId] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
